---
title: TypedArray.prototype.filter()
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/filter
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Prototype
  - TypedArray
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>filter()</code></strong> method creates a new typed array with all elements that pass the test implemented by the provided function. This method has the same algorithm as {{jsxref("Array.prototype.filter()")}}. <em>TypedArray</em> is one of the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array types</a> here.</p>

<div>{{EmbedInteractiveExample("pages/js/typedarray-filter.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>typedarray</var>.filter(<var>callback</var>[, <var>thisArg</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>Function to test each element of the typed array. Invoked with arguments <code>(<var>element</var>, <var>index</var>, <var>typedarray</var>)</code>. Return <code>true</code> to keep the element, <code>false</code> otherwise.</dd>
 <dt><code><var>thisArg</var></code>{{optional_inline}}</dt>
 <dd>Value to use as <code>this</code> when executing <code><var>callback</var></code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new typed array with the elements that pass the test.</p>

<h2 id="Description">Description</h2>

<p>The <code>filter()</code> method calls a provided <code><var>callback</var></code> function once for each element in a typed array, and constructs a new typed array of all the values for which <code><var>callback</var></code> returns <a href="/en-US/docs/Glossary/Truthy">a value that coerces to <code>true</code></a>. <code><var>callback</var></code> is invoked only for indexes of the typed array which have assigned values; it is not invoked for indexes which have been deleted or which have never been assigned values. Typed array elements which do not pass the <code><var>callback</var></code> test are skipped, and are not included in the new typed array.</p>

<p><code><var>callback</var></code> is invoked with three arguments:</p>

<ol>
 <li>the value of the element</li>
 <li>the index of the element</li>
 <li>the typed array object being traversed</li>
</ol>

<p>If a <code><var>thisArg</var></code> parameter is provided to <code>filter()</code>, it will be passed to <code><var>callback</var></code> when invoked, for use as its <code>this</code> value. Otherwise, the value <code>undefined</code> will be passed for use as its <code>this</code> value. The <code>this</code> value ultimately observable by <code><var>callback</var></code> is determined according to <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">the usual rules for determining the <code>this</code> seen by a function</a>.</p>

<p><code>filter()</code> does not mutate the typed array on which it is called.</p>

<p>The range of elements processed by <code>filter()</code> is set before the first invocation of <code><var>callback</var></code>. Elements which are appended to the typed array after the call to <code>filter()</code> begins will not be visited by <code><var>callback</var></code>. If existing elements of the typed array are changed, or deleted, their value as passed to <code><var>callback</var></code> will be the value at the time <code>filter()</code> visits them; elements that are deleted are not visited.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Filtering_out_all_small_values">Filtering out all small values</h3>

<p>The following example uses <code>filter()</code> to create a filtered typed array that has all elements with values less than 10 removed.</p>

<pre class="brush: js notranslate">function isBigEnough(element, index, array) {
  return element &gt;= 10;
}
new Uint8Array([12, 5, 8, 130, 44]).filter(isBigEnough);
// Uint8Array [ 12, 130, 44 ]
</pre>

<h3 id="Filtering_typed_array_elements_using_arrow_functions">Filtering typed array elements using arrow functions</h3>

<p><a href="/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions">Arrow functions</a> provide a shorter syntax for the same test.</p>

<pre class="brush: js notranslate">new Uint8Array([12, 5, 8, 130, 44]).filter(elem =&gt; elem &gt;= 10);
// Uint8Array [ 12, 130, 44 ]</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-%typedarray%.prototype.filter', 'TypedArray.prototype.filter')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.TypedArray.filter")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("TypedArray.prototype.every()")}}</li>
 <li>{{jsxref("TypedArray.prototype.some()")}}</li>
 <li>{{jsxref("Array.prototype.filter()")}}</li>
</ul>
